"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _cli = require("@yarnpkg/cli");

var _core = require("@yarnpkg/core");

var _clipanion = require("clipanion");

var _Constraints = require("../../Constraints");

var _dec, _dec2, _class, _descriptor, _class2, _temp;

function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

// eslint-disable-next-line arca/no-default-export
let ConstraintsSourceCommand = (_dec = _clipanion.Command.Boolean(`-v,--verbose`), _dec2 = _clipanion.Command.Path(`constraints`, `source`), (_class = (_temp = _class2 = class ConstraintsSourceCommand extends _cli.BaseCommand {
  constructor(...args) {
    super(...args);

    _initializerDefineProperty(this, "verbose", _descriptor, this);
  }

  async execute() {
    const configuration = await _core.Configuration.find(this.context.cwd, this.context.plugins);
    const {
      project
    } = await _core.Project.find(configuration, this.context.cwd);
    const constraints = await _Constraints.Constraints.find(project);
    this.context.stdout.write(this.verbose ? constraints.fullSource : constraints.source);
  }

}, _class2.usage = _clipanion.Command.Usage({
  category: `Constraints-related commands`,
  description: `print the source code for the constraints`,
  details: `
      This command will print the Prolog source code used by the constraints engine. Adding the \`-v,--verbose\` flag will print the *full* source code, including the fact database automatically compiled from your workspaces manifests.
    `,
  examples: [[`Prints the source code`, `yarn constraints source`], [`Print the source code and the fact database`, `yarn constraints source -v`]]
}), _temp), (_descriptor = _applyDecoratedDescriptor(_class.prototype, "verbose", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function () {
    return false;
  }
}), _applyDecoratedDescriptor(_class.prototype, "execute", [_dec2], Object.getOwnPropertyDescriptor(_class.prototype, "execute"), _class.prototype)), _class));
exports.default = ConstraintsSourceCommand;